program ClassExampleTest;
uses SysUtils, ClassExample;

type
   TDerivTest = class (TTestClass)
      procedure HelloExpose;
      procedure Overloaded (arg : String); overload;
   end;

   procedure TDerivTest.HelloExpose;
   begin
      Write ('Exposed: '); HelloProtected;
   end;

   procedure TDerivTest.Overloaded (arg : String);
   begin
      WriteLn ('TDerivTest.Overloaded: ', arg);
   end;

var
   V : TDerivTest;
begin
   V := TDerivTest.Create ('First Data');
   //V.HelloLocal;
   V.Hello;
   V.HelloExpose;
   V.Overloaded (17);
   V.Destroy;
end.