{Violation of object model semantics not detected by the language.}
program TestInh;
type
   TParent = object
      field1 : Integer;
      function test : Integer; virtual;
      constructor Init;
   end;
   TChild = object (TParent)
      field2 : Integer;
      function test : Integer; virtual;      
      constructor Init;
   end;
   
   procedure CheckParent (o : TParent);
   begin
      WriteLn ('CheckParent test = ', o.test)
   end;
   
   procedure CheckChild (o : TChild);
   begin
      WriteLn ('CheckChild test = ', o.test)
   end;
   
   function TParent.test : Integer;
   begin
      test := field1
   end;
   
   constructor TParent.Init;
   begin
      field1 := 1
   end;
   
   function TChild.test : Integer;
   begin
      test := field2
   end;
   
   constructor TChild.Init;
   begin
      field1 := 1;
      field2 := 2
   end;

var
   Parent : TParent;
   Child : TChild;

begin
   Parent.Init;
   Child.Init;
   CheckParent (Parent);
   CheckParent (Child);
   CheckChild (Child)
end.