unit TClassExample_slides;

interface

type
   TTestClass = class
   strict private
      procedure HelloPrivate;
   private
      Data : String;
      procedure HelloLocal;
   protected
      procedure HelloProtected;
   public
      constructor Create (AData : String);
      procedure Hello;
   end;
   
implementation

procedure TTestClass.HelloPrivate;
begin
   WriteLn ('TTestClass.HelloPrivate: ', Data);
end;

procedure TTestClass.HelloLocal;
begin
   WriteLn ('TTestClass.HelloLocal: ', Data);
end;

procedure TTestClass.HelloProtected;
begin
   WriteLn ('TTestClass.HelloProtected: ', Data);
end;

procedure TTestClass.Hello;
begin
   Write ('TTestClass.Hello: calling '); HelloPrivate;
   WriteLn ('continuing TTestClass.Hello: ', Data);
end;

constructor TTestClass.Create (AData : String);
begin
   Data := AData;
end;

var L : TTestClass;

begin
   L := TTestClass.Create ('Initializer');
   //L.HelloPrivate;
   L.HelloLocal;
   L.Destroy;
end.
